/*
	TODO:

	- support multiple bit widths and sample rates for data
*/

#ifndef __SPEECHY_H__
#define __SPEECHY_H__

#include "mad.h"

#define END_SEQ			1000
#define ERR_SEQ			1001

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE 1
#endif


typedef struct SPEECHY_ALLOPHONE
{
	int length;
	int16_t *data;
}SPEECHY_ALLOPHONE;


typedef struct SPEECHY_VOICE
{
	int freq;			// Sample rate
	int max;			// max number of allophones
	int count;			// next allophone to allocate
	SPEECHY_ALLOPHONE *table;		// table of allophones

	short *sequence;			// allophones to be played
	int pos;					// current sample position in current signal
}SPEECHY_VOICE;



SPEECHY_VOICE *speechy_init(int count, int freq);
void speechy_exit(SPEECHY_VOICE *voice);

int speechy_add(SPEECHY_VOICE *voice, int16_t *buffer, int length);
int speechy_add_silence(SPEECHY_VOICE *voice, int length);
int speechy_sequence(SPEECHY_VOICE *voice, short *sequence);
int speechy_read(SPEECHY_VOICE *voice, int16_t *samples_out,
	int length);
void speechy_reset(SPEECHY_VOICE *voice);


#endif
